Puzzle

App · 25 actions

Read company accounting data, transactions, journal entries, bills, invoices, accounts, customers, vendors, statements and financial metrics.

Actions

ActionWhat it does
Get Balance Sheet StatementGet Balance Sheet Statement.
Get BillGet Bill.
Get BillsGet Bills.
Get Cash Activity StatementGet Cash Activity Statement.
Get Chart of AccountsGet Chart of Accounts.
Get companiesGet companies.
Get CompanyGet Company.
Get Current UserGet Current User.
Get CustomersGet Customers.
Get Expense MetricsGet Expense Metrics.
Get Financial Account BalancesGet Financial Account Balances.
Get Financial AccountsGet Financial Accounts.
Get Income StatementGet Income Statement.
Get InvoiceGet Invoice.
Get InvoicesGet Invoices.
Get Journal EntriesGet Journal Entries.
Get Ledger AccountGet Ledger Account.
Get Puzzle CategoriesGet Puzzle Categories.
Get RequestsGet Requests.
Get Revenue MetricsGet Revenue Metrics.
Get Spending MetricsGet Spending Metrics.
Get TasksGet Tasks.
Get TransactionGet Transaction.
Get TransactionsGet Transactions.
Get VendorsGet Vendors.

Get Balance Sheet Statement

Get Balance Sheet Statement.

Inputs

CompanyidtextRequired
The company ID
Basisbasistext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: cash, accrual.
ViewByviewBytext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month, quarter, year, totals, departments.
StartPeriodstartPeriodtext
Startperiod
EndPeriodendPeriodtext
Endperiod
DateMacrodateMacrotext
DatemacroOne of: CurrentMonth, LastFullMonth, LastThreeMonths, LastThreeFullMonths, CurrentYear, LastYear, QuarterToDate, YearToDate.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "columns": [],
    "lines": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Bill

Get Bill.

Inputs

CompanyidtextRequired
The company ID
BillIdbillIdtextRequired
The bill ID

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "amount": null,
    "currentness": "Current",
    "description": null,
    "documents": [],
    "dueDate": null,
    "externalId": null,
    "id": "example",
    "issueDate": "example",
    "lines": [],
    "paidAt": null,
    "provider": null,
    "status": "Deleted",
    "submittedAt": null,
    "userId": "example",
    "vendorId": "example",
    "voidedAt": null
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Bills

Get Bills.

Inputs

CompanyidtextRequired
The company ID
IsLinkedisLinkedtext
Boolean flag; "true" enables, any other value disables
IsPaidisPaidtext
Boolean flag; "true" enables, any other value disables
IsSubmittedisSubmittedtext
Boolean flag; "true" enables, any other value disables
IsVoidedisVoidedtext
Boolean flag; "true" enables, any other value disables
MinAmountminAmounttext
Arbitrary-precision decimal, serialized as a string
MaxAmountmaxAmounttext
Arbitrary-precision decimal, serialized as a string
From valuefrom_valuetext
Calendar date, YYYY-MM-DD
Tototext
Calendar date, YYYY-MM-DD
DueDateFromdueDateFromtext
Calendar date, YYYY-MM-DD
DueDateTodueDateTotext
Calendar date, YYYY-MM-DD
Statusesstatusestext
StatusesOne of: Draft, Voided, Paid, Unpaid, Current, Overdue.
VendorIdsvendorIdstext
Partner-facing external identifier
SortBysortBytext
SortbyOne of: AMOUNT_DESC, AMOUNT_ASC, DESCRIPTOR_DESC, DESCRIPTOR_ASC, DUE_DATE_DESC, DUE_DATE_ASC, ISSUE_DATE_DESC, ISSUE_DATE_ASC, VENDOR_DESC, VENDOR_ASC.
Countcountnumber
Count
Afteraftertext
After

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    },
    "total": {
      "amount": "example",
      "currency": "example"
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Cash Activity Statement

Get Cash Activity Statement.

Inputs

CompanyidtextRequired
The company ID
ViewByviewBytext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month, quarter, year, totals, departments.
StartPeriodstartPeriodtext
Startperiod
EndPeriodendPeriodtext
Endperiod
DateMacrodateMacrotext
DatemacroOne of: CurrentMonth, LastFullMonth, LastThreeMonths, LastThreeFullMonths, CurrentYear, LastYear, QuarterToDate, YearToDate.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "columns": [],
    "lines": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Chart of Accounts

Get Chart of Accounts.

Inputs

CompanyidtextRequired
The company ID
Basisbasistext
BasisOne of: cash, accrual.
StartDatestartDatedate
Startdate
EffectiveDateeffectiveDatetext
Calendar date, YYYY-MM-DD
NominalCodenominalCodetext
Nominalcode
GetRestrictedgetRestrictedtext
Boolean flag; "true" enables, any other value disables

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "accounts": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get companies

Get companies.

Inputs

Limitlimitnumber
Page size for modern client credentials (default 100, maximum 100); ignored for OAuth and upstream users.From 1 to 100.
Cursorcursortext
Pagination cursor for modern client credentials; ignored for OAuth and upstream users.
Includeincludetext
Adds integrationHealth to each company. Requires puzzle-client-id, Authorization: Bearer <client secret>, read:company, an active firm authorization and a nonremoved firm-client link. Ignored for OAuth and upstream users.One of: integration_health.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "companies": [],
    "nextCursor": null
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Company

Get Company.

Inputs

CompanyidtextRequired
The company ID

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "financialSummary": null,
    "id": "example",
    "institutionConnections": [],
    "metadata": null,
    "name": "example",
    "status": "Ready"
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Current User

Get Current User.

Inputs

None.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "companies": [],
    "id": "example"
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Customers

Get Customers.

Inputs

CompanyidtextRequired
The company ID
Namenametext
Name
Typetypetext
TypeOne of: Individual, Business, Unknown.
Statusstatustext
StatusOne of: Active, Inactive, Unknown.
Countcountnumber
Count
Afteraftertext
After

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Expense Metrics

Get Expense Metrics.

Inputs

CompanyidtextRequired
The company ID
StartDatestartDatedateRequired
Calendar date, YYYY-MM-DD
EndDateExclusiveendDateExclusivetext
Calendar date, YYYY-MM-DD
Intervalintervaltext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "metrics": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Financial Account Balances

Get Financial Account Balances.

Inputs

CompanyidtextRequired
The company ID
DatesdatesdateRequired
Date to retrieve account balances for.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "balancesByDate": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Financial Accounts

Get Financial Accounts.

Inputs

CompanyidtextRequired
The company ID

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "accounts": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Income Statement

Get Income Statement.

Inputs

CompanyidtextRequired
The company ID
Basisbasistext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: cash, accrual.
ViewByviewBytext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month, quarter, year, totals, departments.
StartPeriodstartPeriodtext
Startperiod
EndPeriodendPeriodtext
Endperiod
DateMacrodateMacrotext
DatemacroOne of: CurrentMonth, LastFullMonth, LastThreeMonths, LastThreeFullMonths, CurrentYear, LastYear, QuarterToDate, YearToDate.
Departmentsdepartmentstext
One or more cls_ classification segment IDs returned by GET /company/{id}/classifications, or the case-insensitive literal "none". Values may be repeated or comma-separated.
Locationslocationstext
One or more cls_ classification segment IDs returned by GET /company/{id}/classifications, or the case-insensitive literal "none". Values may be repeated or comma-separated.
ExpandCounterpartiesexpandCounterpartiestext
Boolean flag; "true" enables, any other value disables
ExpandRevenueSourcesexpandRevenueSourcestext
Boolean flag; "true" enables, any other value disables

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "columns": [],
    "lines": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Invoice

Get Invoice.

Inputs

CompanyidtextRequired
The company ID
InvoiceIdinvoiceIdtextRequired
The invoice ID

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "amount": {
      "amount": "example",
      "currency": "example"
    },
    "contractId": null,
    "customerId": null,
    "description": null,
    "documents": [],
    "dueDate": null,
    "id": "example",
    "issueDate": null,
    "lines": [],
    "nativeId": null,
    "status": "Deleted"
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Invoices

Get Invoices.

Inputs

CompanyidtextRequired
The company ID
From valuefrom_valuetext
Calendar date, YYYY-MM-DD
Tototext
Calendar date, YYYY-MM-DD
CustomerIdscustomerIdstext
Partner-facing external identifier
Statusesstatusestext
StatusesOne of: Deleted, Draft, Posted, Voided, Paid.
CoaKeyscoaKeystext
Chart-of-accounts key
IsPaidisPaidtext
Boolean flag; "true" enables, any other value disables
MinAmountminAmounttext
Arbitrary-precision decimal, serialized as a string
MaxAmountmaxAmounttext
Arbitrary-precision decimal, serialized as a string
SortBysortBytext
SortbyOne of: AMOUNT_DESC, AMOUNT_ASC, CUSTOMER_DESC, CUSTOMER_ASC, DESCRIPTOR_DESC, DESCRIPTOR_ASC, DUE_DATE_DESC, DUE_DATE_ASC, ISSUE_DATE_DESC, ISSUE_DATE_ASC.
Countcountnumber
Count
Afteraftertext
After

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    },
    "total": {
      "amount": "example",
      "currency": "example"
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Journal Entries

Get Journal Entries.

Inputs

CompanyidtextRequired
The company ID
Limitlimitnumber
Limit
Cursorcursortext
Cursor
Basisbasistext
BasisOne of: cash, accrual.
CreatedAftercreatedAfterdate and time
ISO 8601 timestamp

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "journalEntries": [],
    "pageInfo": {
      "nextCursor": null
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Ledger Account

Get Ledger Account.

Inputs

CompanyidtextRequired
The company ID
LedgerAccountIdledgerAccountIdtextRequired
The ledger account ID
Basisbasistext
BasisOne of: cash, accrual.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "accountId": null,
    "category": "example",
    "coaKeys": [],
    "currentBalance": {
      "amount": "example",
      "currency": "example"
    },
    "currentBalanceWithoutSubAccounts": {
      "amount": "example",
      "currency": "example"
    },
    "currentness": null,
    "description": null,
    "id": "example",
    "isBankAccount": false,
    "keywords": [],
    "name": "example",
    "nominalCode": "example",
    "parentCode": null,
    "restrictedCoaKeys": [],
    "subCategory": null,
    "tags": [],
    "tertiaryCategory": null,
    "type": "example",
    "views": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Puzzle Categories

Get Puzzle Categories.

Inputs

None.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "categories": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Requests

Get Requests.

Inputs

CompanyidtextRequired
The company ID
Statusstatustext
Status
Typetypetext
Type
TransactionIdstransactionIdstext
Partner-facing external identifier
RequestedUserIdsrequestedUserIdstext
Partner-facing external identifier
RequestedByUserIdsrequestedByUserIdstext
Partner-facing external identifier
StartDatestartDatedate
Calendar date, YYYY-MM-DD
EndDateendDatedate
Calendar date, YYYY-MM-DD

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "requests": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Revenue Metrics

Get Revenue Metrics.

Inputs

CompanyidtextRequired
The company ID
StartDatestartDatedateRequired
Calendar date, YYYY-MM-DD
EndDateExclusiveendDateExclusivetext
Calendar date, YYYY-MM-DD
Intervalintervaltext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "metrics": []
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Spending Metrics

Get Spending Metrics.

Inputs

CompanyidtextRequired
The company ID
StartDatestartDatedateRequired
Calendar date, YYYY-MM-DD
EndDateExclusiveendDateExclusivetext
Calendar date, YYYY-MM-DD
Intervalintervaltext
The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of: month.

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "endPeriod": "example",
    "nonPayrollMetrics": [],
    "payrollMetrics": [],
    "startPeriod": "example"
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Tasks

Get Tasks.

Inputs

CompanyidtextRequired
The company ID
Statusstatustext
Status
Typetypetext
Type
AssigneeIdsassigneeIdstext
Partner-facing external identifier
TransactionIdstransactionIdstext
Partner-facing external identifier
CreatedBycreatedBytext
Partner-facing external identifier
CreatedAftercreatedAfterdate and time
ISO 8601 timestamp
Countcountnumber
Count
Afteraftertext
After

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Transaction

Get Transaction.

Inputs

IncludeCategorizationincludeCategorizationtext
Include categorization attribution and history only when "true"; omitted by default
CompanyidtextRequired
The company ID
TransactionIdtransactionIdtextRequired
The transaction ID

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "accountId": null,
    "actorType": "SYSTEM_ACTOR",
    "amount": {
      "amount": "example",
      "currency": "example"
    },
    "categorization": {
      "confirmationStatus": "CONFIRMED",
      "confirmedAt": null,
      "details": [],
      "detailsConfirmationStatus": "CONFIRMED",
      "lastHumanConfirmation": null,
      "status": "CATEGORIZED"
    },
    "category": null,
    "classifications": null,
    "coaKey": null,
    "customerId": null,
    "descriptor": "example",
    "documents": null,
    "id": "example",
    "memo": null,
    "nativeId": null,
    "status": "Finalized",
    "timestamp": "example",
    "vendorId": null
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Transactions

Get Transactions.

Inputs

IncludeCategorizationincludeCategorizationtext
Include categorization attribution and history only when "true"; omitted by default
CompanyidtextRequired
The company ID
StartDatestartDatedateRequired
Calendar date, YYYY-MM-DD
EndDateendDatedateRequired
Calendar date, YYYY-MM-DD
AccountIdsaccountIdstext
Partner-facing external identifier
VendorIdsvendorIdstext
Partner-facing external identifier
CoaKeyscoaKeystext
Coakeys
Statusstatustext
StatusOne of: Finalized, NotFinalized, NotCategorized.
SortBysortBytext
SortbyOne of: ABS_AMOUNT_ASC, ABS_AMOUNT_DESC, AMOUNT_ASC, AMOUNT_DESC, DATE_ASC, DATE_DESC, DESCRIPTION_ASC, DESCRIPTION_DESC, NAME_ASC, UNCATEGORIZED_AMOUNT_DESC, VENDOR_ASC, VENDOR_DESC.
Afteraftertext
After
Countcountnumber
Count

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

Get Vendors

Get Vendors.

Inputs

CompanyidtextRequired
The company ID
Typetypetext
TypeOne of: Individual, Business, Unknown.
Statusstatustext
StatusOne of: Active, Inactive, Unknown.
PermaNamespermaNamestext
Permanames
Is1099Vendoris1099Vendortext
Boolean flag; "true" enables, any other value disables
Countcountnumber
Count
Afteraftertext
After

Outputs

dataobject
The response returned by the service.
has_moretrue/false
Whether another page is available.
next_cursortext
Continuation token for the next page.
Example output
{
  "data": {
    "items": [],
    "pageInfo": {
      "endCursor": null,
      "hasNextPage": false,
      "total": null
    }
  },
  "has_more": false,
  "next_cursor": "example"
}

On this page